#include "cdk.h"

/*
 * $Author: glover $
 * $Date: 1995/12/10 19:13:47 $
 * $Revision: 1.16 $
 */

/*
 * This inserts a binding.
 */
void bindCDKObject (EObjectType cdktype, void *object, chtype key, BINDFN function, void * data)
{
   int index	= mapChtype (key);

   /* Since dereferencing a void pointer is a no-no, we have to cast	*/
   /* our pointer correctly.						*/
   if (cdktype == vENTRY)
   {
      ((CDKENTRY *)object)->bindFunction[index]		= function;
      ((CDKENTRY *)object)->bindData[index]		= data;
   }
   else if (cdktype == vMENTRY)
   {
      ((CDKMENTRY *)object)->bindFunction[index]	= function;
      ((CDKMENTRY *)object)->bindData[index]		= data;
   }
   else if (cdktype == vSCROLL)
   {
      ((CDKSCROLL *)object)->bindFunction[index]	= function;
      ((CDKSCROLL *)object)->bindData[index]		= data;
   }
   else if (cdktype == vDIALOG)
   {
      ((CDKDIALOG *)object)->bindFunction[index]	= function;
      ((CDKDIALOG *)object)->bindData[index]		= data;
   }
   else if (cdktype == vSCALE)
   {
      ((CDKSCALE *)object)->bindFunction[index]		= function;
      ((CDKSCALE *)object)->bindData[index]		= data;
   }
   else if (cdktype == vMENU)
   {
      ((CDKMENU *)object)->bindFunction[index]		= function;
      ((CDKMENU *)object)->bindData[index]		= data;
   }
   else if (cdktype == vMATRIX)
   {
      ((CDKMATRIX *)object)->bindFunction[index]	= function;
      ((CDKMATRIX *)object)->bindData[index]		= data;
   }
   else if (cdktype == vSELECTION)
   {
      ((CDKSELECTION *)object)->bindFunction[index]	= function;
      ((CDKSELECTION *)object)->bindData[index]		= data;
   }
   else if (cdktype == vVIEWER)
   {
      ((CDKVIEWER *)object)->bindFunction[index]	= function;
      ((CDKVIEWER *)object)->bindData[index]		= data;
   }
   else if (cdktype == vRADIO)
   {
      ((CDKRADIO *)object)->bindFunction[index]		= function;
      ((CDKRADIO *)object)->bindData[index]		= data;
   }
   else if (cdktype == vTEMPLATE)
   {
      ((CDKTEMPLATE *)object)->bindFunction[index]	= function;
      ((CDKTEMPLATE *)object)->bindData[index]		= data;
   }
   else if (cdktype == vSWINDOW)
   {
      ((CDKSWINDOW *)object)->bindFunction[index]	= function;
      ((CDKSWINDOW *)object)->bindData[index]		= data;
   }
   else if (cdktype == vITEMLIST)
   {
      ((CDKITEMLIST *)object)->bindFunction[index]	= function;
      ((CDKITEMLIST *)object)->bindData[index]		= data;
   }
   else if (cdktype == vFSELECT)
   {
      bindCDKObject (vENTRY, ((CDKFSELECT *)object)->filename, key, function, data);
      bindCDKObject (vSCROLL, ((CDKFSELECT *)object)->filelist, key, function, data);
   }
}

/*
 * This removes a binding on an object.
 */
void unbindCDKObject (EObjectType cdktype, void *object, chtype key)
{
   int index	= mapChtype(key);

   /* Since dereferencing a void pointer is a no-no, we have to cast	*/
   /* our pointer correctly.						*/
   if (cdktype == vENTRY)
   {
      ((CDKENTRY *)object)->bindFunction[index]		= (BINDFN)NULL;
      ((CDKENTRY *)object)->bindData[index]		= (void *)NULL;
   }
   else if (cdktype == vMENTRY)
   {
      ((CDKMENTRY *)object)->bindFunction[index]	= (BINDFN)NULL;
      ((CDKMENTRY *)object)->bindData[index]		= (void *)NULL;
   }
   else if (cdktype == vSCROLL)
   {
      ((CDKSCROLL *)object)->bindFunction[index]	= (BINDFN)NULL;
      ((CDKSCROLL *)object)->bindData[index]		= (void *)NULL;
   }
   else if (cdktype == vDIALOG)
   {
      ((CDKDIALOG *)object)->bindFunction[index]	= (BINDFN)NULL;
      ((CDKDIALOG *)object)->bindData[index]		= (void *)NULL;
   }
   else if (cdktype == vSCALE)
   {
      ((CDKSCALE *)object)->bindFunction[index]		= (BINDFN)NULL;
      ((CDKSCALE *)object)->bindData[index]		= (void *)NULL;
   }
   else if (cdktype == vMENU)
   {
      ((CDKMENU *)object)->bindFunction[index]		= (BINDFN)NULL;
      ((CDKMENU *)object)->bindData[index]		= (void *)NULL;
   }
   else if (cdktype == vMATRIX)
   {
      ((CDKMATRIX *)object)->bindFunction[index]	= (BINDFN)NULL;
      ((CDKMATRIX *)object)->bindData[index]		= (void *)NULL;
   }
   else if (cdktype == vSELECTION)
   {
      ((CDKSELECTION *)object)->bindFunction[index]	= (BINDFN)NULL;
      ((CDKSELECTION *)object)->bindData[index]		= (void *)NULL;
   }
   else if (cdktype == vVIEWER)
   {
      ((CDKVIEWER *)object)->bindFunction[index]	= (BINDFN)NULL;
      ((CDKVIEWER *)object)->bindData[index]		= (void *)NULL;
   }
   else if (cdktype == vRADIO)
   {
      ((CDKRADIO *)object)->bindFunction[index]		= (BINDFN)NULL;
      ((CDKRADIO *)object)->bindData[index]		= (void *)NULL;
   }
   else if (cdktype == vTEMPLATE)
   {
      ((CDKTEMPLATE *)object)->bindFunction[index]	= (BINDFN)NULL;
      ((CDKTEMPLATE *)object)->bindData[index]		= (void *)NULL;
   }
   else if (cdktype == vSWINDOW)
   {
      ((CDKSWINDOW *)object)->bindFunction[index]	= (BINDFN)NULL;
      ((CDKSWINDOW *)object)->bindData[index]		= (void *)NULL;
   }
   else if (cdktype == vITEMLIST)
   {
      ((CDKITEMLIST *)object)->bindFunction[index]	= (BINDFN)NULL;
      ((CDKITEMLIST *)object)->bindData[index]		= (void *)NULL;
   }
   else if (cdktype == vFSELECT)
   {
      unbindCDKObject (vENTRY, ((CDKFSELECT *)object)->filename, key);
      unbindCDKObject (vSCROLL, ((CDKFSELECT *)object)->filelist, key);
   }
}

/*
 * This sets all the bindings for the given objects.
 */
void cleanCDKObjectBindings (EObjectType cdktype, void *object)
{
   /* Since dereferencing a void pointer is a no-no, we have to cast	*/
   /* our pointer correctly.						*/
   if (cdktype == vENTRY)
   {
      int x;
      for (x=0; x < MAXBINDINGS; x++)
      {
         ((CDKENTRY *)object)->bindFunction[x]		= (BINDFN)NULL;
         ((CDKENTRY *)object)->bindData[x]		= (void *)NULL;
      }
   }
   else if (cdktype == vMENTRY)
   {
      int x;
      for (x=0; x < MAXBINDINGS; x++)
      {
         ((CDKMENTRY *)object)->bindFunction[x]		= (BINDFN)NULL;
         ((CDKMENTRY *)object)->bindData[x]		= (void *)NULL;
      }
   }
   else if (cdktype == vSCROLL)
   {
      int x;
      for (x=0; x < MAXBINDINGS; x++)
      {
         ((CDKSCROLL *)object)->bindFunction[x]		= (BINDFN)NULL;
         ((CDKSCROLL *)object)->bindData[x]		= (void *)NULL;
      }
   }
   else if (cdktype == vDIALOG)
   {
      int x;
      for (x=0; x < MAXBINDINGS; x++)
      {
         ((CDKDIALOG *)object)->bindFunction[x]		= (BINDFN)NULL;
         ((CDKDIALOG *)object)->bindData[x]		= (void *)NULL;
      }
   }
   else if (cdktype == vSCALE)
   {
      int x;
      for (x=0; x < MAXBINDINGS; x++)
      {
         ((CDKSCALE *)object)->bindFunction[x]		= (BINDFN)NULL;
         ((CDKSCALE *)object)->bindData[x]		= (void *)NULL;
      }
   }
   else if (cdktype == vMENU)
   {
      int x;
      for (x=0; x < MAXBINDINGS; x++)
      {
         ((CDKMENU *)object)->bindFunction[x]		= (BINDFN)NULL;
         ((CDKMENU *)object)->bindData[x]		= (void *)NULL;
      }
   }
   else if (cdktype == vMATRIX)
   {
      int x;
      for (x=0; x < MAXBINDINGS; x++)
      {
         ((CDKMATRIX *)object)->bindFunction[x]		= (BINDFN)NULL;
         ((CDKMATRIX *)object)->bindData[x]		= (void *)NULL;
      }
   }
   else if (cdktype == vSELECTION)
   {
      int x;
      for (x=0; x < MAXBINDINGS; x++)
      {
         ((CDKSELECTION *)object)->bindFunction[x]	= (BINDFN)NULL;
         ((CDKSELECTION *)object)->bindData[x]		= (void *)NULL;
      }
   }
   else if (cdktype == vVIEWER)
   {
      int x;
      for (x=0; x < MAXBINDINGS; x++)
      {
         ((CDKVIEWER *)object)->bindFunction[x]		= (BINDFN)NULL;
         ((CDKVIEWER *)object)->bindData[x]		= (void *)NULL;
      }
   }
   else if (cdktype == vRADIO)
   {
      int x;
      for (x=0; x < MAXBINDINGS; x++)
      {
         ((CDKRADIO *)object)->bindFunction[x]		= (BINDFN)NULL;
         ((CDKRADIO *)object)->bindData[x]		= (void *)NULL;
      }
   }
   else if (cdktype == vTEMPLATE)
   {
      int x;
      for (x=0; x < MAXBINDINGS; x++)
      {
         ((CDKTEMPLATE *)object)->bindFunction[x]	= (BINDFN)NULL;
         ((CDKTEMPLATE *)object)->bindData[x]		= (void *)NULL;
      }
   }
   else if (cdktype == vSWINDOW)
   {
      int x;
      for (x=0; x < MAXBINDINGS; x++)
      {
         ((CDKSWINDOW *)object)->bindFunction[x]	= (BINDFN)NULL;
         ((CDKSWINDOW *)object)->bindData[x]		= (void *)NULL;
      }
   }
   else if (cdktype == vITEMLIST)
   {
      int x;
      for (x=0; x < MAXBINDINGS; x++)
      {
         ((CDKITEMLIST *)object)->bindFunction[x]	= (BINDFN)NULL;
         ((CDKITEMLIST *)object)->bindData[x]		= (void *)NULL;
      }
   }
   else if (cdktype == vFSELECT)
   {
      cleanCDKObjectBindings (vENTRY, ((CDKFSELECT *)object)->filename);
      cleanCDKObjectBindings (vSCROLL, ((CDKFSELECT *)object)->filelist);
   }
}

/*
 * This checks to see iof the binding for the key exists. If it does then it
 * runs the command and returns a TRUE. If it doesn't it returns a FALSE. This
 * way we can 'overwrite' coded in bindings.
 */
int checkCDKObjectBind (EObjectType cdktype, void *object, chtype key)
{
   int index	= mapChtype (key);

   /* Since dereferencing a void pointer is a no-no, we have to cast	*/
   /* our pointer correctly.						*/
   if (cdktype == vENTRY)
   {
      if ( ((CDKENTRY *)object)->bindFunction[index] != (BINDFN) NULL )
      {
         BINDFN function	= (BINDFN) ((CDKENTRY *)object)->bindFunction[index];
         void * data		= (void *) ((CDKENTRY *)object)->bindData[index];
         function (vENTRY, object, data);
         return (TRUE);
      }
   }
   else if (cdktype == vMENTRY)
   {
      if ( ((CDKMENTRY *)object)->bindFunction[index] != (BINDFN) NULL )
      {
         BINDFN function	= ((CDKMENTRY *)object)->bindFunction[index];
         void * data		= ((CDKMENTRY *)object)->bindData[index];
         function (vMENTRY, object, data);
         return (TRUE);
      }
   }
   else if (cdktype == vSCROLL)
   {
      if ( ((CDKSCROLL *)object)->bindFunction[index] != (BINDFN) NULL )
      {
         BINDFN function	= ((CDKSCROLL *)object)->bindFunction[index];
         void * data		= ((CDKSCROLL *)object)->bindData[index];
         function (vSCROLL, object, data);
         return (TRUE);
      }
   }
   else if (cdktype == vDIALOG)
   {
      if ( ((CDKDIALOG *)object)->bindFunction[index] != (BINDFN) NULL )
      {
         BINDFN function	= ((CDKDIALOG *)object)->bindFunction[index];
         void * data		= ((CDKDIALOG *)object)->bindData[index];
         function (vDIALOG, object, data);
         return (TRUE);
      }
   }
   else if (cdktype == vSCALE)
   {
      if ( ((CDKSCALE *)object)->bindFunction[index] != (BINDFN) NULL )
      {
         BINDFN function	= ((CDKSCALE *)object)->bindFunction[index];
         void * data		= ((CDKSCALE *)object)->bindData[index];
         function (vSCALE, object, data);
         return (TRUE);
      }
   }
   else if (cdktype == vMENU)
   {
      if ( ((CDKMENU *)object)->bindFunction[index] != (BINDFN) NULL )
      {
         BINDFN function	= ((CDKMENU *)object)->bindFunction[index];
         void * data		= ((CDKMENU *)object)->bindData[index];
         function (vMENU, object, data);
         return (TRUE);
      }
   }
   else if (cdktype == vMATRIX)
   {
      if ( ((CDKMATRIX *)object)->bindFunction[index] != (BINDFN) NULL )
      {
         BINDFN function	= ((CDKMATRIX *)object)->bindFunction[index];
         void * data		= ((CDKMATRIX *)object)->bindData[index];
         function (vMATRIX, object, data);
         return (TRUE);
      }
   }
   else if (cdktype == vSELECTION)
   {
      if ( ((CDKSELECTION *)object)->bindFunction[index] != (BINDFN) NULL )
      {
         BINDFN function	= ((CDKSELECTION *)object)->bindFunction[index];
         void * data		= ((CDKSELECTION *)object)->bindData[index];
         function (vSELECTION, object, data);
         return (TRUE);
      }
   }
   else if (cdktype == vVIEWER)
   {
      if ( ((CDKVIEWER *)object)->bindFunction[index] != (BINDFN) NULL )
      {
         BINDFN function	= ((CDKVIEWER *)object)->bindFunction[index];
         void * data		= ((CDKVIEWER *)object)->bindData[index];
         function (vVIEWER, object, data);
         return (TRUE);
      }
   }
   else if (cdktype == vRADIO)
   {
      if ( ((CDKRADIO *)object)->bindFunction[index] != (BINDFN) NULL )
      {
         BINDFN function	= ((CDKRADIO *)object)->bindFunction[index];
         void * data		= ((CDKRADIO *)object)->bindData[index];
         function (vRADIO, object, data);
         return (TRUE);
      }
   }
   else if (cdktype == vTEMPLATE)
   {
      if ( ((CDKTEMPLATE *)object)->bindFunction[index] != (BINDFN) NULL )
      {
         BINDFN function	= ((CDKTEMPLATE *)object)->bindFunction[index];
         void * data		= ((CDKTEMPLATE *)object)->bindData[index];
         function (vTEMPLATE, object, data);
         return (TRUE);
      }
   }
   else if (cdktype == vSWINDOW)
   {
      if ( ((CDKSWINDOW *)object)->bindFunction[index] != (BINDFN) NULL )
      {
         BINDFN function	= ((CDKSWINDOW *)object)->bindFunction[index];
         void * data		= ((CDKSWINDOW *)object)->bindData[index];
         function (vSWINDOW, object, data);
         return (TRUE);
      }
   }
   else if (cdktype == vITEMLIST)
   {
      if ( ((CDKITEMLIST *)object)->bindFunction[index] != (BINDFN) NULL )
      {
         BINDFN function	= ((CDKITEMLIST *)object)->bindFunction[index];
         void * data		= ((CDKITEMLIST *)object)->bindData[index];
         function (vITEMLIST, object, data);
         return (TRUE);
      }
   }
   return (FALSE);
}

/*
 * This translates non ascii characters like KEY_UP to an 'equivalent'
 * ascii value.
 */
int mapChtype (chtype key)
{
   if (key == KEY_UP)
   {
       return (257);
   }
   else if (key == KEY_DOWN)
   {
       return (258);
   }
   else if (key == KEY_LEFT)
   {
       return (259);
   }
   else if (key == KEY_RIGHT)
   {
       return (260);
   }
   else if (key == KEY_NPAGE)
   {
       return (261);
   }
   else if (key == KEY_PPAGE)
   {
       return (262);
   }
   else if (key == KEY_HOME)
   {
       return (263);
   }
   else if (key == KEY_END)
   {
       return (264);
   }
   else if (key == KEY_F0)
   {
       return (265);
   }
   else if (key == KEY_F1)
   {
       return (266);
   }
   else if (key == KEY_F2)
   {
       return (267);
   }
   else if (key == KEY_F3)
   {
       return (268);
   }
   else if (key == KEY_F4)
   {
       return (269);
   }
   else if (key == KEY_F5)
   {
       return (270);
   }
   else if (key == KEY_F6)
   {
       return (271);
   }
   else if (key == KEY_F7)
   {
       return (272);
   }
   else if (key == KEY_A1)
   {
       return (273);
   }
   else if (key == KEY_A3)
   {
       return (274);
   }
   else if (key == KEY_B2)
   {
       return (275);
   }
   else if (key == KEY_C1)
   {
       return (276);
   }
   else if (key == KEY_C3)
   {
       return (277);
   }
   else if (key == KEY_ESC)
   {
       return (278);
   }
   else 
   {
      return ( (char) key );
   }
}
