#include "cdk.h"

FILE *CDKDEBUG ;

/*
 * $Author: glover $
 * $Date: 1995/12/10 18:38:39 $
 * $Revision: 1.90 $
 */

/* This beeps then flushes the stdout stream.			*/
void Beep()
{
   beep();
   fflush (stdout);
}

/* This is my 'own' version of bzero.				*/
void cleanChar (char *s, int len, char character)
{
   int x;
   for (x=0; x < len; x++)
   {
      s[x] = character;
   }
   s[--x] = '\0';
}
void cleanChtype (chtype *s, int len, chtype character)
{
   int x;
   for (x=0; x < len; x++)
   {
      s[x] = character;
   }
   s[--x] = '\0';
}

/*
 * This takes an x and y position and realigns the values iff they sent in
 * values like CENTER, LEFT, RIGHT, ...
 */
void alignxy (WINDOW *window, int *xpos, int *ypos, int boxwidth, int boxheight)
{
   /* Justify the X position, if we need to.			*/
   if ((*xpos) == LEFT)
   {
      (*xpos) = window->_begy + 1;
   }
   else if ((*xpos) == RIGHT)
   {
      (*xpos) = (window->_maxx - boxwidth) + window->_begy - 1;
   }
   else if ((*xpos) == CENTER)
   {
      (*xpos) = (int)(((window->_maxx)-boxwidth) / 2) + window->_begy;
   }
   else
   {
      /* If we have gone out of bounds, then readjust.		*/
      if ( ((*xpos) + boxwidth) > window->_maxx)
      {
         (*xpos) = (window->_maxx - boxwidth);
      }
      else if ( (*xpos) < 0 )
      {
         (*xpos) = window->_begy + 1;
      }
   }

   /* Justify the Y position, if we need to.			*/
   if ((*ypos) == TOP)
   {
      (*ypos) = window->_begx + 1;
   }
   else if ((*ypos) == BOTTOM)
   {
      (*ypos) = (window->_maxy) - boxheight + window->_begx - 1;
   }
   else if ((*ypos) == CENTER)
   {
      (*ypos) = (int)((window->_maxy - boxheight) / 2) + window->_begx;
   }
   else
   {
      /* If we have gone out of bounds, then readjust		*/
      if ( ((*ypos) + boxheight) > window->_maxy)
      {
         (*ypos) = (window->_maxy - boxheight);
      }
      else if ( (*ypos) < 0 )
      {
         (*ypos) = window->_begx + 1;
      }
   }
}

/*
 * This creates the x and y offset values given the location and size of the
 * given label for the object.
 */
void alignlabel (char *label, int lplace, int fieldwidth, int *boxwidth, int *boxheight, int *labelxoffset, int *labelyoffset, int *fieldxoffset, int *fieldyoffset)
{
   /* Declare local variables.					*/
   int labelLength	= strlen (label);

   /* Set the offset values.					*/
   if (lplace == LEFT)
   { 
      (*boxwidth)	= fieldwidth + labelLength + 3;
      (*labelxoffset)	= 1;
      (*labelyoffset)	= 1;
      (*fieldxoffset)	= labelLength + 2;
      (*fieldyoffset)	= 1;
   }
   else if (lplace == RIGHT)
   {
      (*boxwidth)	= fieldwidth + labelLength + 3;
      (*labelxoffset)	= ((*boxwidth) - labelLength - 1);
      (*labelyoffset)	= 1;
      (*fieldxoffset)	= 1;
      (*fieldyoffset)	= 1;
   }
   else if (lplace == TOP)
   {
      (*boxwidth)	= (fieldwidth < labelLength ? labelLength : fieldwidth);
      (*boxwidth)	+= 3;
      (*boxheight)	= (*boxheight) + 1;
      (*labelxoffset)	= (int) (((*boxwidth)-labelLength)/2);
      (*labelyoffset)	= 1;
      (*fieldyoffset)	= 2;
      (*fieldxoffset)	= 1;
   }
   else if (lplace == BOTTOM)
   {
      (*boxwidth)	= (fieldwidth < labelLength ? labelLength : fieldwidth) + 3;
      (*boxheight)	= (*boxheight) + 1;
      (*labelxoffset)	= (int) (((*boxwidth)-labelLength)/2);
      (*labelyoffset)	= (*boxheight)-2;
      (*fieldxoffset)	= 1;
      (*fieldyoffset)	= 1;
   }
   else
   {
     /*
      * Give me something I don't understand and I 
      * will choose a default for you ie: LEFT
      */
      (*boxwidth)	= fieldwidth + labelLength + 3;
      (*labelxoffset)	= 1;
      (*labelyoffset)	= 1;
      (*fieldxoffset)	= labelLength + 2;
      (*fieldyoffset)	= 1;
   }
}

/*
 * This takes a string, a field width and a justifycation type
 * and returns the justifcation adjustment to make, to fill
 * the justification requirement.
 */
int justifyMessage (int width, char *mesg, int justify)
{
   int mesglen	= strlen (mesg);

   /* Make sure the message isn't longer than the width.	*/
   /* If it is, return 0.					*/
   if (mesglen >= width)
   {
      return (0);
   }

   /* Try to justify the message.				*/
   if (justify == LEFT)
   {
      return (1);
   }
   else if (justify == RIGHT)
   {
      return ( (width - mesglen));
   }
   else if (justify == CENTER)
   {
      return ( (int)((width - mesglen) / 2) );
   }
   else
   {
      return ( justify );
   }
}
int justifyString (int boxWidth, int mesgLength, int justify)
{
   /* Make sure the message isn't longer than the width.	*/
   /* If it is, return 1.					*/
   if (mesgLength >= boxWidth)
   {
      return (1);
   }

   /* Try to justify the message.				*/
   if (justify == LEFT)
   {
      return (1);
   }
   else if (justify == RIGHT)
   {
      return ( (boxWidth - mesgLength - 1) );
   }
   else if (justify == CENTER)
   {
      return ( (int)((boxWidth - mesgLength) / 2) );
   }
   else
   {
      return ( justify );
   }
}

/*
 * This returns a substring of the given string.
 */
char *substring(char *string, int start, int width)
{
   char *newstring	= (char *)NULL;
   int mesglen		= (strlen (string));
   int y		= 0;
   int x		= 0;
   int lastchar		= 0;

   if (start > mesglen)
   {
      return ( newstring );
   }

   newstring	= (char *)malloc (sizeof (char) * (width+3));
   cleanChar (newstring, width+3, '\0');
   if ( (start+width) > mesglen)
   {
      lastchar = mesglen;
   }
   else
   {
      lastchar = width + start;
   }

   for (x=start; x<=lastchar; x++)
   {
      newstring[y++] = string[x];
   }
   return ( newstring );
}

/*
 * This frees a string if it is not null. This is a safety
 * measure. Some compilers let you free a null string. I
 * don't like that idea.
 */
void freeChar (char *string)
{
   if (string != (char *)NULL)
   {
      free (string);
   }
}
void freeChtype (chtype *string)
{
   if (string != (chtype *)NULL)
   {
      free (string);
   }
}

/*
 * This performs a safe copy of a string. This means it adds the NULL
 * terminator on the end of the string.
 */
char *copyChar (char *original)
{
   /* Declare local variables.					*/
   char *newstring;
   int len	= strlen (original);

   /* Create the new string.					*/
   newstring	= (char *)malloc (sizeof(char) * (len+3));
   cleanChar (newstring, len+3, '\0');

   /* Copy from one to the other...				*/
   strcpy (newstring, original);

   /* Return the new string.					*/
   return (newstring);
}
chtype *copyChtype (chtype *original)
{
   /* Declare local variables.					*/
   chtype *newstring;
   int len	= chlen (original);
   int x;

   /* Create the new string.					*/
   newstring	= (chtype *)malloc (sizeof(chtype) * (len+4));
   cleanChtype (newstring, len+3, '\0');
 
   /* Copy from one to the other...				*/
   for (x=0; x < len; x++)
   {
      newstring[x]	= original[x];
   }

   /* Return the new string.					*/
   return (newstring);
}


/*
 * This draws a line in a scrolling list or a selection list.
 */
void drawScrollItem (WINDOW *win, char *item, int woffset, int hoffset, int voffset, int width, chtype attr)
{
   char *tmp = substring(item, voffset, width);
   if (tmp != (char *)NULL)
   {
      printattr (win, hoffset, woffset, HORIZONTAL, attr, tmp);
      free (tmp);
   }
}

/*
 * This reads a file and sticks it into the char ** provided.
 */
int readFile (char *filename, char **array, int maxlines)
{
   FILE	*fd;
   char temp[515];
   int	lines	= 0;

   /* Clean out temp...						*/
   cleanChar (temp, 514, '\0');

   /* Can we open the file?					*/
   if ( (fd = fopen (filename, "r")) == NULL)
   {
      return (0);
   }
                                                                                
   /* Start reading the file in.				*/
   while ( (fgets (temp, 512, fd) != (char *)NULL) && lines < maxlines)
   {
      int len		= strlen(temp);
      temp[len]		= '\0';
      array[lines]	= copyChar (temp);
      lines++;
   }
   fclose (fd);

   /* Clean up and return.					*/
   array[lines]		= "";
   return (lines);
}

/*
 * This function takes a character string, full of format markers
 * and translates them into a chtype * array. This is better suited
 * to curses, because curses uses chtype almost exclusively
 */
chtype *char2Chtype (char *string, int *to, int *align)
{
   chtype *newstring	= (chtype *)NULL;
   chtype attrib	= A_NORMAL;
   int insideMarker	= FALSE;
   int start		= 0;
   int from		= 0;
   int pair		= 0;
   int x 		= 3;
   int len		= 0;
   char temp[5];

   /* Is the string NULL???					*/
   if ( string == (char *)NULL)
   {
      return ( (chtype *)NULL );
   }

   /* Get the length of the string.				*/
   len		= strlen(string);

   /* Set up some default values...				*/
   (*to)		= 0;
   (*align)		= LEFT;
   temp[0]		= '\0';
   pair			= 0;

   /* Lets make sure the string isn't null.			*/
   if (string == (char *)NULL)
   {
      return ( newstring );
   }

   /* Lets make some room for the chtype string...		*/
   newstring		= (chtype *)malloc (sizeof(chtype) * (len+4));
   cleanChtype (newstring, len+4, '\0');

   /* Look for an alignment marker.				*/
   if (string[0] == '<' && string[1] == 'C' && string[2] == '>')
   {
      (*align)	= CENTER;
      start	= 3;
   }
   else if (string[0] == '<' && string[1] == 'R' && string[2] == '>')
   {
      (*align)	= RIGHT;
      start	= 3;
   }
   else if (string[0] == '<' && string[1] == 'L' && string[2] == '>')
   {
      (*align)	= LEFT;
      start	= 3;
   }
   else if (string[0] == '<' && string[1] == 'T' && string[2] == '>')
   {
      (*align)	= TOP;
      start	= 3;
   }
   else if (string[0] == '<' && string[1] == 'B' && string[2] == '>')
   {
      (*align)	= BOTTOM;
      start	= 3;
   }
   else if (string[0] == '<' && string[1] == 'I' && string[2] == '=')
   {
      /* Set the item index value in the string.		*/
      newstring[0] = ' '; newstring[1] = ' '; newstring[2] = ' ';

      /* Pull out the bullet marker.				*/
      while (string[x] != '>')
      {
         newstring[x] = string[x] | A_BOLD;
         x++;
      }
      newstring[x++] = ' ';

      /* Set the alignment variables.				*/
      (*align)	= LEFT;
      start	= x;
      (*to)	= x;
   }
      
   /* Set the format marker boolean to false.			*/
   insideMarker	= FALSE;

   /* Start parsing the character string...			*/
   for (from=start; from < len; from++)
   {
      /* Are we inside a format marker???			*/
      if ( ! insideMarker )
      {
         if (string[from] == '<' && string[from+1] == '/')
         {
            insideMarker = 1;
         }
         else if (string[from] == '<' && string[from+1] == '!')
         {
            insideMarker = 1;
         }
         else if (string[from] == '\\' && string[from+1] == '<')
         {
            from++;
            newstring[(*to)++]	= string[from++] | attrib;
         }
         else
         {
            newstring[(*to)++]	= string[from] | attrib;
         }
      }
      else
      {
         /* We are in the format marker.			*/
         if (string[from] == '>')
         {
            insideMarker = 0;
         }
         else if (string[from] == '/' && string[from+1] == 'B')
         {
            attrib	= attrib | A_BOLD;
            from++;
         }
         else if (string[from] == '!' && string[from+1] == 'B')
         {
            attrib	= attrib & (~A_BOLD);
            from++;
         }
         else if (string[from] == '/' && string[from+1] == 'U')
         {
            attrib	= attrib | A_UNDERLINE;
            from++;
         }
         else if (string[from] == '!' && string[from+1] == 'U')
         {
            attrib	= attrib & (~A_UNDERLINE);
            from++;
         }
         else if (string[from] == '/' && string[from+1] == 'S')
         {
            attrib	= attrib | A_STANDOUT;
            from++;
         }
         else if (string[from] == '!' && string[from+1] == 'S')
         {
            attrib	= attrib & (~A_STANDOUT);
            from++;
         }
         else if (string[from] == '/' && string[from+1] == 'R')
         {
            attrib	= attrib | A_REVERSE;
            from++;
         }
         else if (string[from] == '!' && string[from+1] == 'R')
         {
            attrib	= attrib & (~A_REVERSE);
            from++;
         }
         else if (string[from] == '/' && string[from+1] == 'K')
         {
            attrib	= attrib | A_BLINK;
            from++;
         }
         else if (string[from] == '!' && string[from+1] == 'K')
         {
            attrib	= attrib & (~A_BLINK);
            from++;
         }
         else if (string[from] == '/' && string[from+1] == 'D')
         {
            attrib	= attrib | A_DIM;
            from++;
         }
         else if (string[from] == '!' && string[from+1] == 'D')
         {
            attrib	= attrib & (~A_DIM);
            from++;
         }
         else if (string[from] == '/' && string[from+1] == 'L')
         {
            /* Since this is a link, we need to create */
#ifdef COLOR
            attrib	= attrib | A_UNDERLINE | COLOR_PAIR(5);
#else
            attrib	= attrib | A_UNDERLINE;
#endif
            from++;
         }
         else if (string[from] == '!' && string[from+1] == 'L')
         {
#ifdef COLOR
            attrib	= attrib & (~A_UNDERLINE) & (~COLOR_PAIR(5));
#else
            attrib	= attrib & (~A_UNDERLINE);
#endif
            from++;
         }
         else if (string[from] == '/' && isdigit(string[from+1]) && isdigit(string[from+2]) )
         {
#ifdef COLOR
            sprintf (temp, "%c%c", string[from+1],string[from+2]);
            pair	= atoi(temp);
            attrib	= attrib | COLOR_PAIR(pair);
#else
            from += 2;
#endif
         }
         else if (string[from] == '!' && isdigit(string[from+1]) && isdigit(string[from+2]) )
         {
#ifdef COLOR
            sprintf (temp, "%c%c", string[from+1],string[from+2]);
            pair	= atoi(temp);
            attrib	= attrib & (~COLOR_PAIR(pair) );
#else
            from += 2;
#endif
         }
         else if (string[from] == '/' && isdigit(string[from+1]) )
         {
#ifdef COLOR
            pair	= string[++from] - '0';
            attrib	= attrib | COLOR_PAIR(pair);
#else
            from++;
#endif
         }
         else if (string[from] == '!' && isdigit(string[from+1]) )
         {
#ifdef COLOR
            pair	= string[++from] - '0';
            attrib	= attrib & (~COLOR_PAIR(pair) );
#else
            from++;
#endif
         }
      }
   }

   /* Return the new string...					*/
   return ( newstring );
}

/*
 * This determines the length of a chtype string
 */
int chlen (chtype *string)
{
   /* Declare local variables.					*/
   int x	= 0;
   while (string[x++] != '\0');
   return ( (x-1) );
}

/*
 * This returns a pointer to char * of a chtype *
 */
char *chtype2Char (chtype *string)
{
   /* Declare local variables.					*/
   char *newstring;
   int len = 0;
   int x;

   /* Is the string NULL???					*/
   if ( string == (chtype *)NULL)
   {
      return ( (char *)NULL );
   }

   /* Get the length of the string.				*/
   len = chlen(string);

   /* Make the new string.					*/
   newstring	= (char *)malloc (sizeof (char) * (len+1));
   cleanChar (newstring, len+1, '\0');

   /* Start translating...					*/
   for (x=0; x < len; x++)
   {
      newstring[x]	= string[x] & A_CHARTEXT;
   }

   /* Force a NULL character on the end of the string.		*/
   newstring[len] = (char)NULL;

   /* Return it.						*/
   return (newstring);
}

void printattr (WINDOW *window, int xpos, int ypos, int align, chtype attr, char *mesg)
{
   int x;

   /* Check the alignment of the message.	*/
   if (align == VERTICAL)
   { 
      int mesgLength = ( (int)strlen (mesg) <= window->_maxy ? (int)strlen (mesg) : window->_maxy);

      /* Draw the message on a vertical axis.	*/
      for (x=0; x < mesgLength ; x++)
      {
         if (attr == A_NOATTRIB)
         {
            mvwaddch (window, xpos+x, ypos, mesg[x]);
         }
         else
         {
            mvwaddch (window, xpos+x, ypos, mesg[x] | attr);
         }
      }
   }
   else
   {
      int mesgLength = ((int)strlen (mesg) <= window->_maxx ? (int)strlen (mesg) : window->_maxx);

      /* Draw the message on a horizontal axis. (default)	*/
      for (x=0; x < mesgLength ; x++)
      {
         if (attr == A_NOATTRIB)
         {
            mvwaddch (window, xpos, ypos+x, mesg[x]);
         }
         else
         {
            mvwaddch (window, xpos, ypos+x, mesg[x] | attr);
         }
      }
   }
}

/*
 * This swaps two elements in an array.
 */
void swapIndex (char *list[], int i, int j)
{
   char *temp;
   temp = list[i];
   list[i] = list[j];
   list[j] = temp;
}

/*
 * This function is a quick sort alg which sort an array of
 * char *. I wanted to use to stdlib qsort, but couldn't get the
 * thing to work, so I wrote my own. I'll use qsort if I can get
 * it to work.
 */
void quickSort (char *list[], int left, int right)
{
   int i, last;

   /* If there are fewer than 2 elements, return.	*/
   if (left >= right)
   {
      return;
   }

   swapIndex (list, left, (left+right)/2);
   last = left;
   
   for (i=left+1; i <= right; i++)
   {
      if (strcmp (list[i], list[left]) < 0)
      {
         swapIndex (list, ++last, i);
      }
   }

   swapIndex (list, left, last);
   quickSort (list, left, last-1);
   quickSort (list, last+1, right);
}
