#include "cdk.h"

void main()
{
   /* Declare variables.			*/
   CDKSCREEN	*cdkscreen;
   CDKDIALOG	*question;
   WINDOW	*cursesWin;
   char		*buttons[40];
   char		*message[40];
   char		temp[100];
   int		selection;
   int		x;

   /* Set up CDK 				*/ 
   cursesWin = initscr();
   cdkscreen = initCDKScreen (cursesWin);

   /* Start color.              		*/
   initCDKColor();

   /* Set up the dialog box.			*/
   for (x=0; x < 20; x++)
   {
      sprintf (temp, "</U/3>%d<!3>", x); buttons[x] = copyChar (temp);
   }

   message[0]	= "<C></5>This is the message region.";
   message[1]	= "<L></B>There can be almost any number";
   message[2]	= "<R></U>of lines here as you wish.";
   message[3]	= "<C></2>This example only displays four lines.";

   /* Create the dialog box.			*/
   question	= newCDKDialog (cdkscreen, CENTER, CENTER, message, 4, buttons, 20, COLOR_PAIR(2), TRUE, TRUE, FALSE);

   /* Check if we got a null value back.	*/
   if (question == (CDKDIALOG *)NULL)
   {
      /* Clean up the memory.			*/
      for (x=0; x < 20; x++)
      {
          free (buttons[x]);
      }
      destroyCDKScreen (cdkscreen);

      /* End curses...				*/
      endCDK();

      /* Spit out a message.			*/
      printf ("Oops. Can't seem to create the dialog box. Is the window too small?\n");
      exit (1);
   }

   /* Activate the dialog box.			*/
   selection	= activateCDKDialog (question);

   /* Clean up					*/
   destroyCDKDialog (question);
   destroyCDKScreen (cdkscreen);
   endCDK();

   /* Destroy the memory the buttons use.	*/
   for (x=0; x < 20; x++)
   {
       free (buttons[x]);
   }
   delwin (cursesWin);

   /* Spit out the info				*/
   printf ("\n\n\n");
   printf ("Button Number Chosen: %d\n", selection);
   exit (0);
}
