#include "cdk.h"

void main()
{
   /* Declare vars			*/
   CDKSCREEN	*cdkscreen;
   CDKENTRY	*directory;
   WINDOW	*cursesWin;
   char		*label;
   char		*info;

   /* Set up CDK 			*/ 
   cursesWin = initscr();
   cdkscreen = initCDKScreen( cursesWin );

   /* Start CDK colors.			*/
   initCDKColor();

   /* Declare the labels.		*/
   label	= "</U/5>Directory:<!U!5>";
   directory	= newCDKEntry (cdkscreen, CENTER, CENTER, LEFT, label, A_NORMAL, '.', vMIXED, 10, 0, 256, &CDKEntryCallBack, TRUE, FALSE);

   /* Is the widget NULL??		*/
   if (directory == (CDKENTRY *)NULL)
   {
      /* Clean up			*/
      destroyCDKScreen (cdkscreen);
      endCDK();

      /* Print out a little message.	*/
      printf ("Oops. Can't seem to create the entry box. Is the window too small?\n");
      exit (1);
   }

   /* Draw the CDK screen.		*/
   refreshCDKScreen ( cdkscreen );

   /* Activate the entry fields.	*/
   info	= strdup(activateCDKEntry (directory) );
   
   /* Clean up				*/
   destroyCDKEntry (directory);
   destroyCDKScreen (cdkscreen);
   delwin (cursesWin);
   endCDK();
  
   /* Spit out what the user typed.	*/
   printf ("info: %s\n", info);
   free(info);
   exit (0);
}
