#include "cdk.h"

#define	MAXINFOLINES	10000

void main(int argc, char **argv)
{
   /* Declare variables.			*/
   CDKSCREEN	*cdkscreen;
   CDKVIEWER	*example;
   CDKFSELECT	*fileSelector;
   WINDOW	*cursesWin;
   char		*filename;
   char		*info[MAXINFOLINES];
   char		*button[25];
   char		title[500];
   int		selected;
   int		lines;
   int		x;

   /* Create the viewer buttons.				*/
   button[0]	= "</5><<OK>><!5>";
   button[1]	= "</5><<Maybe>><!5>";
   button[2]	= "</5><<Maybe Not>><!5>";
   button[3]	= "</5><<Cancel>><!5>";

   /* Set up CDK 						*/ 
   cursesWin = initscr();
   cdkscreen = initCDKScreen ( cursesWin );

   /* Start color.						*/
   initCDKColor();

   /* Get the filename.						*/
   fileSelector = newCDKFselect (cdkscreen, CENTER, CENTER, 20, 55,
			A_NORMAL, '.', COLOR_PAIR(48)|A_REVERSE,
			"</5>", "</48>", "</N>", "</N>",
			TRUE, FALSE);
 
   /* Activate the file selector.				*/
   filename = activateCDKFselect (fileSelector);

   /* Check if the value was NULL.				*/
   if ( filename == (char *)NULL )
   {
      /* Exit CDK.						*/
      destroyCDKFselect (fileSelector);
      destroyCDKScreen (cdkscreen);
      endCDK();

      /* Print out a message and exit.				*/
      printf ("No file selected.\n");
      exit (0);
   }

   /* Create the viewer.					*/
   example = newCDKViewer (cdkscreen,
		CENTER, CENTER, 20, 70,
		button, 1, TRUE, FALSE);

   /* Is the viewer pointer NULL??				*/
   if (example == (CDKVIEWER *)NULL)
   {
      /* Exit CDK.						*/
      destroyCDKFselect (fileSelector);
      destroyCDKScreen (cdkscreen);
      endCDK();

      /* Print out a message and exit.				*/
      printf ("Oops. Can't seem to create viewer. Is the window too small?\n");
      exit (0);
   }

   /* Set up the info.						*/
   lines = readFile (filename, info, MAXINFOLINES);
   if (lines == 0)
   {
      printf ("Could not open %s\n", filename);
      exit (1);
   }

   /* Make it run...						*/
   sprintf (title, "<C></B/21>Filename:<!21></22>%20s<!22!B>", filename);
   selected = activateCDKViewer (example, title, info, lines,
		COLOR_PAIR(21)|A_REVERSE, TRUE, TRUE);

   /* Clean up.							*/
   destroyCDKViewer (example);
   destroyCDKFselect (fileSelector);
   destroyCDKScreen (cdkscreen);
   delwin (cursesWin);
   endCDK();
   for (x=0; x < lines; x++)
   {
      freeChar (info[x]);
   }

   /* Spit out some info.					*/
   printf ("\n\n\n\n");
   printf ("You picked button %d\n", selected);
}
