#include "cdk.h"

void main()
{
   /* Declare vars			*/
   CDKSCREEN	*cdkscreen;
   CDKGRAPH	*graph;
   CDKLABEL	*pause;
   WINDOW	*cursesWin;
   char	*mesg[2], *title, *xtitle, *ytitle;
   chtype graphchars[20];
   int values[20], colors[20];
   int count;

   /* Set up CDK			*/ 
   cursesWin = initscr();
   cdkscreen = initCDKScreen ( cursesWin );

   /* Start CDK Colors			*/
   initCDKColor();

   /* Create the graph values.		*/
   values[0]	= 10;	graphchars[0]	= '*'|A_NORMAL;	colors[0]	= 5;
   values[1]	= 15;	graphchars[1]	= '*'|A_NORMAL;	colors[1]	= 5;
   values[2]	= 20;	graphchars[2]	= '*'|A_NORMAL;	colors[2]	= 5;
   values[3]	= 25;	graphchars[3]	= '*'|A_NORMAL;	colors[3]	= 5;
   values[4]	= 30;	graphchars[4]	= '*'|A_NORMAL;	colors[4]	= 5;
   values[5]	= 35;	graphchars[5]	= '*'|A_NORMAL;	colors[5]	= 5;
   values[6]	= 40;	graphchars[6]	= '*'|A_NORMAL;	colors[6]	= 5;
   values[7]	= 45;	graphchars[7]	= '*'|A_NORMAL;	colors[7]	= 5;
   values[8]	= 50;	graphchars[8]	= '*'|A_NORMAL;	colors[8]	= 5;
   values[9]	= 55;	graphchars[9]	= '*'|A_NORMAL;	colors[9]	= 5;
   count	= 10;
   title	= "<C>Test Graph";
   xtitle	= "<C>X AXIS TITLE";
   ytitle	= "<C>Y AXIS TITLE";
  
   /* Create the label values.		*/
   mesg[0]	= "Press Any Key When Done Viewing The Graph.";

   /* Create the graph widget		*/
   graph = newCDKGraph (cdkscreen, CENTER, CENTER, 10, 20, title, xtitle, ytitle);

   /* Is the graph NULL???		*/
   if (graph == (CDKGRAPH *)NULL)
   {
      /* Shut down CDK.			*/
      destroyCDKScreen (cdkscreen);
      endCDK();

      /* Print out a message and exit.	*/
      printf ("Oops. Can not make the graph widget. Is the window too small?\n");
      exit (1);
   }

   /* Create the label widget.		*/
   pause = newCDKLabel (cdkscreen, CENTER, BOTTOM, mesg, 1, TRUE, FALSE);
   if ( pause == (CDKLABEL *)NULL)
   {
      /* Shut down CDK.			*/
      destroyCDKGraph (graph);
      destroyCDKScreen (cdkscreen);
      endCDK();

      /* Print out a message and exit.	*/
      printf ("Oops. Can not make the label widget. Is the window too small?\n");
      exit (1);
   }

   /* Set the graph values.		*/
   setCDKGraph (graph, values, count, FALSE, graphchars, colors, vPLOT);

   /* Draw the screen.			*/
   refreshCDKScreen (cdkscreen);
   drawCDKGraph (graph, BOX);
   drawCDKLabel (pause, BOX);

   /* Pause until the user says so...	*/
   waitCDKLabel (pause, (char)NULL);

   /* Clean up.                         */
   destroyCDKGraph (graph);
   destroyCDKLabel (pause);
   destroyCDKScreen (cdkscreen);
   delwin (cursesWin);
   endCDK();
   exit (0);
}
