#include "cdk.h"

void main()
{
   /* Declare vars			*/
   CDKSCREEN	*cdkscreen;
   CDKHISTOGRAM	*volume;
   CDKHISTOGRAM	*bass;
   CDKHISTOGRAM	*treble;
   WINDOW	*cursesWin;
   char *volumeLabel, *bassLabel, *trebleLabel;

   /* Set up CDK 			*/ 
   cursesWin = initscr();
   cdkscreen = initCDKScreen ( cursesWin );

   /* Start CDK Color			*/
   initCDKColor();

   /* Set up the histogram labels.	*/
   volumeLabel	= "</5>Volume<!5>";
   bassLabel	= "</5>Bass  <!5>";
   trebleLabel	= "</5>Treble<!5>";

   /* Create the histogram objects.	*/
   volume	= newCDKHistogram (cdkscreen, 10, 10, LEFT, 1, 20, HORIZONTAL, volumeLabel, TRUE, FALSE);
   if (volume == (CDKHISTOGRAM *)NULL)
   {
      /* Exit CDK.			*/
      destroyCDKScreen (cdkscreen);
      endCDK();
      
      /* Print out a message and exit.	*/
      printf ("Oops. Can not make volume histogram. Is the window big enough??\n");
      exit (1);
   }

   bass		= newCDKHistogram (cdkscreen, 10, 12, LEFT, 1, 20, HORIZONTAL, bassLabel, TRUE, FALSE);
   if (bass == (CDKHISTOGRAM *)NULL)
   {
      /* Exit CDK.			*/
      destroyCDKHistogram (volume);
      destroyCDKScreen (cdkscreen);
      endCDK();

      /* Print out a message and exit.	*/
      printf ("Oops. Can not make bass histogram. Is the window big enough??\n");
      exit (1);
   }

   treble	= newCDKHistogram (cdkscreen, 10, 14, LEFT, 1, 20, HORIZONTAL, trebleLabel, TRUE, FALSE);
   if (treble == (CDKHISTOGRAM *)NULL)
   {
      /* Exit CDK.			*/
      destroyCDKHistogram (volume);
      destroyCDKHistogram (bass);
      destroyCDKScreen (cdkscreen);
      endCDK();

      /* Print out a message and exit.	*/
      printf ("Oops. Can not make treble histogram. Is the window big enough??\n");
      exit (1);
   }

   /* Set the histogram values.		*/
   setCDKHistogram (volume, vPERCENT, CENTER, A_BOLD, 0, 10, 6, ' '|A_REVERSE|COLOR_PAIR(3), BOX);
   setCDKHistogram (bass  , vPERCENT, CENTER, A_BOLD, 0, 10, 3, ' '|A_REVERSE|COLOR_PAIR(3), BOX);
   setCDKHistogram (treble, vPERCENT, CENTER, A_BOLD, 0, 10, 7, ' '|A_REVERSE|COLOR_PAIR(3), BOX);
   refreshCDKScreen (cdkscreen);
   sleep (4);

   /* Set the histogram values.		*/
   setCDKHistogram (volume, vPERCENT, CENTER, A_BOLD, 0, 10, 8, ' '|A_REVERSE|COLOR_PAIR(3), BOX);
   setCDKHistogram (bass  , vPERCENT, CENTER, A_BOLD, 0, 10, 1, ' '|A_REVERSE|COLOR_PAIR(3), BOX);
   setCDKHistogram (treble, vPERCENT, CENTER, A_BOLD, 0, 10, 9, ' '|A_REVERSE|COLOR_PAIR(3), BOX);
   refreshCDKScreen (cdkscreen);
   sleep (4);

   /* Set the histogram values.		*/
   setCDKHistogram (volume, vPERCENT, CENTER, A_BOLD, 0, 10, 10, ' '|A_REVERSE|COLOR_PAIR(3), BOX);
   setCDKHistogram (bass  , vPERCENT, CENTER, A_BOLD, 0, 10, 7, ' '|A_REVERSE|COLOR_PAIR(3), BOX);
   setCDKHistogram (treble, vPERCENT, CENTER, A_BOLD, 0, 10, 10, ' '|A_REVERSE|COLOR_PAIR(3), BOX);
   refreshCDKScreen (cdkscreen);
   sleep (4);

   /* Set the histogram values.		*/
   setCDKHistogram (volume, vPERCENT, CENTER, A_BOLD, 0, 10, 1, ' '|A_REVERSE|COLOR_PAIR(3), BOX);
   setCDKHistogram (bass  , vPERCENT, CENTER, A_BOLD, 0, 10, 8, ' '|A_REVERSE|COLOR_PAIR(3), BOX);
   setCDKHistogram (treble, vPERCENT, CENTER, A_BOLD, 0, 10, 3, ' '|A_REVERSE|COLOR_PAIR(3), BOX);
   refreshCDKScreen (cdkscreen);
   sleep (4);

   /* Set the histogram values.		*/
   setCDKHistogram (volume, vPERCENT, CENTER, A_BOLD, 0, 10, 3, ' '|A_REVERSE|COLOR_PAIR(3), BOX);
   setCDKHistogram (bass  , vPERCENT, CENTER, A_BOLD, 0, 10, 3, ' '|A_REVERSE|COLOR_PAIR(3), BOX);
   setCDKHistogram (treble, vPERCENT, CENTER, A_BOLD, 0, 10, 3, ' '|A_REVERSE|COLOR_PAIR(3), BOX);
   refreshCDKScreen (cdkscreen);
   sleep (4);

   /* Clean up.				*/
   destroyCDKHistogram (volume);
   destroyCDKHistogram (bass);
   destroyCDKHistogram (treble);
   destroyCDKScreen (cdkscreen);
   delwin (cursesWin);
   endCDK();
   exit (0);
}
