#include "cdk.h"

void main()
{
   /* Declare vars			*/
   CDKSCREEN	*cdkscreen;
   CDKITEMLIST	*monthlist;
   WINDOW	*cursesWin;
   char		*label;
   char		*info[MAXITEMS];
   int		choice;

   /* Set up CDK 			*/ 
   cursesWin = initscr();
   cdkscreen = initCDKScreen( cursesWin );

   /* Start CDK colors.			*/
   initCDKColor();

   /* Create the choice list.		*/
   info[0]	= "<C></5>January";
   info[1]	= "<C></5>Feburary";
   info[2]	= "<C></5>March";
   info[3]	= "<C></5>April";
   info[4]	= "<C></5>May";
   info[5]	= "<C></5>June";
   info[6]	= "<C></5>July";
   info[7]	= "<C></5>August";
   info[8]	= "<C></5>September";
   info[9]	= "<C></5>October";
   info[10]	= "<C></5>November";
   info[11]	= "<C></5>December";

   /* Declare the labels.		*/
   label	= "</U/5>Pick a Month:<!U!5>";
   monthlist	= newCDKItemlist (
			cdkscreen,
			CENTER, CENTER, LEFT,
			label, info, 12, 5, TRUE, FALSE);

   /* Is the widget NULL??		*/
   if (monthlist == (CDKITEMLIST *)NULL)
   {
      /* Clean up			*/
      destroyCDKScreen (cdkscreen);
      endCDK();

      /* Print out a little message.	*/
      printf ("Oops. Can't seem to create the entry box. Is the window too small?\n");
      exit (1);
   }

   /* Draw the CDK screen.		*/
   refreshCDKScreen (cdkscreen);

   /* Activate the widget.		*/
   choice = activateCDKItemlist (monthlist);

   /* Clean up.				*/
   destroyCDKItemlist (monthlist);
   destroyCDKScreen (cdkscreen);
   delwin (cursesWin);
   endCDK();
 
   /* Spit out what the user typed.	*/
   printf ("You picked choice #%d which is %s\n", choice, info[choice]);
   exit (0);
}
