#include "cdk.h"

void main()
{
   /* Declare vars	*/
   CDKSCREEN	*cdkscreen;
   CDKMATRIX	*testmatrix;
   WINDOW	*cursesWin;
   int		colwidth[10];
   int		colvalue[10];
   char		*coltitle[10];
   char		*rowtitle[10];

   int rows = 8;
   int cols = 5;
   int vrows = 3;
   int vcols = 5;
   int x, y;

   /* Set up CDK */ 
   cursesWin = initscr();
   cdkscreen = initCDKScreen ( cursesWin );

   /* Start CDK Colors.		*/
   initCDKColor();

   /* Set up the matrix	*/
   coltitle[1] = "</B/5>Course";   colwidth[1] = 7 ; colvalue[1] = vUMIXED;
   coltitle[2] = "</B/44>Lec 1";    colwidth[2] = 7 ; colvalue[2] = vUMIXED;
   coltitle[3] = "</B/44>Lec 2";    colwidth[3] = 7 ; colvalue[3] = vUMIXED;
   coltitle[4] = "</B/44>Lec 3";    colwidth[4] = 7 ; colvalue[4] = vUMIXED;
   coltitle[5] = "</B/7>Flag";     colwidth[5] = 1 ; colvalue[5] = vUMIXED;
   rowtitle[1] = "</B/6>Course 1"; rowtitle[2] = "<C></B/6>Course 2";
   rowtitle[3] = "</B/6>Course 3"; rowtitle[4] = "<L></B/6>Course 4";
   rowtitle[5] = "</B/6>Course 5"; rowtitle[6] = "<R></B/6>Course 6"; 
   rowtitle[7] = "</B/6>Course 7"; rowtitle[8] = "<R></B/6>Course 8"; 

   /* Create the matrix object.	*/
   testmatrix = newCDKMatrix (cdkscreen,
					CENTER, CENTER,
					rows, cols, vrows, vcols,
					rowtitle, coltitle,
					colwidth, colvalue, 
					1, 1, '.',
					COL, &CDKMatrixCallBack,
					TRUE, TRUE, TRUE);

   /* Check to see if the matrix is NULL.	*/
   if ( testmatrix == (CDKMATRIX *)NULL )
   {
      /* Clean up.				*/
      destroyCDKScreen (cdkscreen);
      endCDK();
 
      /* Print out a little message.		*/
      printf ("Oops. Can't seem to create the entry box. Is the window too small ?\n");
      exit (1);
   }

   /* Activate the matrix.	*/
   activateCDKMatrix (testmatrix);

   /* Spit out the info.	*/
   printf ("\n\n\n");
   for (x=1; x <= rows; x++)
   {
      for (y=1; y <= cols; y++)
      {
         printf ("(%d,%d) = '%s'\t", x, y, testmatrix->info[x][y]);
      }
      printf ("\n");
   }

   /* Clean up.			*/
   destroyCDKMatrix (testmatrix);
   destroyCDKScreen (cdkscreen);
   delwin (cursesWin);
   endCDK();
   exit (0);
}
