#include "cdk.h"

void main()
{
   /* Declare variables.	*/
   CDKSCREEN	*cdkscreen;
   CDKMENTRY	*filename;
   WINDOW	*cursesWin;
   char		*info;
   char		*label	= "</5>Filename:<!5>";

   /* Set up CDK 		*/ 
   cursesWin = initscr();
   cdkscreen = initCDKScreen ( cursesWin );

   /* Start CDK Colors.		*/
   initCDKColor();

   /* Set up the multi-line entry field.	*/
   filename	= newCDKMentry (cdkscreen, CENTER, CENTER, LEFT, label, A_BOLD, '.', vMIXED, 20, 5, 20, 0, &CDKMentryCallBack, TRUE, FALSE);

   /* Is the object NULL?	*/
   if ( filename == (CDKMENTRY *)NULL)
   {
      /* Shut down CDK.		*/
      destroyCDKScreen (cdkscreen);
      endCDK();

      /* Print out a message.	*/
      printf ("Oops. Can not create CDK object. Is the window too small?\n");
      exit (1);
   }

   /* Draw the CDK screen.	*/
   refreshCDKScreen ( cdkscreen );

   /* Activate this thing.	*/
   activateCDKMentry (filename);
   info	= strdup (filename->info);

   /* Clean up.	*/
   destroyCDKMentry (filename);
   destroyCDKScreen (cdkscreen);
   delwin (cursesWin);
   endCDK();

   /* Spit out the results.	*/
   printf ("\n\n\n");
   printf ("Filename : <%s>\n", info);
   free(info);
   exit (0);
}
