#include "cdk.h"

void main()
{
   /* Declare vars		*/
   CDKSCREEN	*cdkscreen;
   CDKSCALE	*testscale;
   WINDOW	*cursesWin;
   int		selection;
   char *label;

   /* Set up CDK		 */ 
   cursesWin = initscr();
   cdkscreen = initCDKScreen ( cursesWin );

   /* Start CDK Colors.		*/
   initCDKColor();

   /* Create the scale.		*/
   label	= "</5>Scale Label:";
   testscale	= newCDKScale (cdkscreen, CENTER, CENTER, CENTER, label, A_NORMAL, 5, 1, 1, 5, 1, 1, TRUE, FALSE);

   /* Is the scale NULL?	*/
   if (testscale == (CDKSCALE *)NULL)
   {
      /* Exit CDK.		*/
      destroyCDKScreen (cdkscreen);
      endCDK();
      
      /* Print out a message.	*/
      printf ("Oops. Can't make the scale widget. Is the window too small?\n");
      exit (1);
   }

   /* Draw the CDK screen.	*/
   refreshCDKScreen ( cdkscreen );

   /* Activate the scale.	*/
   selection	= activateCDKScale (testscale);

   /* Clean up.	*/
   destroyCDKScale (testscale);
   destroyCDKScreen (cdkscreen);
   delwin (cursesWin);
   endCDK();

   /* Spit out the info.	*/
   printf ("\n\n\n");
   printf ("Selection: %d\n", selection);
   exit (0);
}
