#include "cdk.h"

void main()
{
   /* Declare variables.		*/
   CDKSCREEN	*cdkscreen;
   CDKTEMPLATE	*codeword;
   WINDOW	*cursesWin;
   char		*info;
   char		*label		= "</5>CODEWORD:<!5>";
   char 	*overlay	= "</B/6>F_ __ __ __ __ __ _L<!6>";
   char 	*plate		= "AA CC cc MM XX xx ##";

   /* Set up CDK 			*/ 
   cursesWin = initscr();
   cdkscreen = initCDKScreen( cursesWin );

   /* Start CDK Colors.			*/
   initCDKColor();

   /* Declare the template.		*/
   codeword	= newCDKTemplate (cdkscreen, CENTER, CENTER, LEFT, label, plate, overlay, &CDKTemplateCallBack, TRUE, TRUE);

   /* Is the template pointer NULL	*/
   if (codeword == (CDKTEMPLATE *)NULL)
   {
      /* Exit CDK.			*/
      destroyCDKScreen (cdkscreen);
      endCDK();

      /* Print out a message and exit.	*/
      printf ("Oops. Can;'t seem to create template. Is the window too small?");
      exit (1);
   }

   /* Draw the CDK screen.		*/
   refreshCDKScreen ( cdkscreen );

   /* Activate the template 		*/
   activateCDKTemplate (codeword);
   info	= strdup (codeword->info);
   
   /* Clean up.				*/
   destroyCDKTemplate (codeword);
   destroyCDKScreen (cdkscreen);
   delwin (cursesWin);
   endCDK();

   /* Print out the info gathered...    */
   printf ("\n\n\n");
   printf ("Code Word: %s\n", info);
   free (info);
   exit (0);
}
